unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, EditAlign, XPMan;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    edxa: TEdit;
    Label3: TLabel;
    edxb: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    edxp: TEdit;
    Label6: TLabel;
    edres: TEdit;
    eda: TEditAlign;
    edb: TEditAlign;
    btncalc: TButton;
    XPManifest1: TXPManifest;
    procedure btncalcClick(Sender: TObject);
    procedure edaKeyPress(Sender: TObject; var Key: Char);
    procedure edxaKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function fat(Num:integer):real;
var
  i:integer;
  temp:real;
begin
  temp:=1;
  for i:= Num downto 1 do
    temp := temp*(i);
  result := temp;
end;

function C(n,p:integer):integer;
begin
  result := trunc(fat(n)/(fat(p)*fat(n-p)));
end;

function pot(b:real;e:integer):real;
begin
  if b < 0 then
    if odd(e) then
      result := exp(ln(abs(b))*e)*-1
    else
      result := exp(ln(abs(b))*e)
  else
    result := exp(ln(b)*e);
end;

procedure TForm1.btncalcClick(Sender: TObject);
var
  ex,ey,ep,tex,tey,i:integer;
  a,b,rtemp:real;
  temp,vari,sinal,coef:string;
begin
  a:= StrToFloat(eda.Text);
  b:= StrToFloat(edb.Text);
  ex:= StrToInt(edxa.Text);
  ey:= StrToInt(edxb.Text);
  ep:= StrToInt(edxp.Text);
  for i:= 0 to ep do
  begin
    rtemp:= C(ep,i)*pot(a,ep - i)*pot(b,i);
    tex:= (ep-i)*ex;
    tey:= i*ey;
    vari := '';
    case tex of
      0:vari:='';
      1:vari:='X';
      2:vari:='X';
      3:vari:='X';
    else
      vari:='X^'+IntToStr(tex);
    end;
    if (vari <> '') and (tey > 0) then vari:=vari+'.';
    case tey of
      0:;
      1:vari:=vari+'Y';
      2:vari:=vari+'Y';
      3:vari:=vari+'Y';
    else
      vari:=vari+'Y^'+IntToStr(tey);
    end;

    if (rtemp > 0) then
      if (i = 0) then sinal := '' else sinal := ' + '
    else sinal := ' - ';
    coef := FloatToStr(abs(rtemp));
    if (rtemp = 1) and (vari <> '') then  coef := '';
    temp := temp + sinal+coef+vari;
  end;
  edres.Text := temp;
end;

procedure TForm1.edaKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin Key := #0; Perform(Wm_NextDlgCtl,0,0); end;
  if not(Key in['0'..'9',#8,'-']) then Key:=#0;
end;

procedure TForm1.edxaKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin Key := #0; Perform(Wm_NextDlgCtl,0,0); end;
  if not(Key in['0'..'9',#8]) then Key:=#0;
end;

end.
